program exponentmax(output);
(* exponentmax: determine the largest argument of the exp() function

  Dr. Thomas D. Schneider
  toms@alum.mit.edu
  permanent email: toms@alum.mit.edu (use only if first address fails)
  https://alum.mit.edu/www/toms/

 *)

label 1; (* end of program *)

const
(* begin module version *)
   version = 1.00; (* of exponentmax.p 2006 Nov 20
2006 Nov 20, 1.00: origin
*)
updateversion = 1.00; (* defines lowest acceptable current parameter file *)
(* end module version *)

(* begin module describe.exponentmax *)
(*
name
   exponentmax: determine the largest argument of the exp() function

synopsis
   exponentmax(output: out)

files

   output: messages to the user

description

   At some value of x, exp(-x) is too large for a particular computer.
   Determine the value.  The program will crash at that point.

examples

   For the GPC compiler on a SunBlade 2000,

exponentmax 1.00
x =    1, exp(-x) =  3.679e-01
x =    2, exp(-x) =  1.353e-01
x =    3, exp(-x) =  4.979e-02
...
x =  743, exp(-x) =  1.98e-323
x =  744, exp(-x) =  9.88e-324
x =  745, exp(-x) =  4.94e-324
./exponentmax: error in exponentiation (Result too large) (error #700 at 180f3)

documentation

see also

   higa.p

author

   Thomas Dana Schneider

bugs

technical notes

*)
(* end module describe.exponentmax *)

(* begin module exponentmax.themain *)
procedure themain;
(* the main procedure of the program *)
var
   parameterversion: real; (* parameter version number *)
   x: integer; (* value to find the maximum of *)
begin
   writeln(output,'exponentmax ',version:4:2);

   for x := 1 to 1000 do begin
       writeln(output,'x = ',x:4,', exp(-x) = ',exp(-x):10);
   end;

end;
(* end module exponentmax.themain *)

begin
   themain;
1: end.
