program nohob(input, output);
(* nohob: no high order bits

  Dr. Thomas D. Schneider, Ph.D.
  toms@alum.mit.edu
  toms@alum.mit.edu (permanent)
  https://alum.mit.edu/www/toms (permanent)

 *)

label 1; (* end of program *)

const
(* begin module version *)
   version = 1.01; (* of nohob.p 2013 Nov 30
2013 Nov 30, 1.01: fix description
2010 Mar 24, 1.00: origin
*)
updateversion = 1.00; (* defines lowest acceptable current parameter file *)
(* end module version *)

(* begin module describe.nohob *)
(*
name
   nohob: no high order bits

synopsis
   nohob(input: in, output: out)

files

   input: input file

   output: the input file with high order bits removed

description

   Remove high order bits that wtch detects.

examples

documentation

see also

   {The} wtch.p {program shows high order bits.}

author

   Thomas Dana Schneider

bugs

technical notes

   The constant defining high order is hardwired in the code.
   ASCII ord of more than 127 is high order.

*)
(* end module describe.nohob *)

(* constant defining high order *)
   HIGH = 127; (* high order bit is on if greater than this value *)

(* begin module halt *)
procedure halt;
(* stop the program.  the procedure performs a goto to the end of the
   program.  you must have a label:
      label 1;
   declared, and also the end of the program must have this label:
      1: end.
   examples are in the module libraries.
   this is the only goto in the delila system. *)
begin
      writeln(output,' program halt.');
      goto 1
end;
(* end module halt version = 'delmod 6.16 84 mar 12 tds/gds'; *)

(* begin module nohob.themain *)
procedure themain;
(* the main procedure of the program *)
var
   c: char; (* a character read from the input *)
begin
{
   parameterversion: real; (* parameter version number *)
   writeln(output,'nohob ',version:4:2);
   reset(nohobp);
   readln(nohobp, parameterversion);
   if round(100*parameterversion) < round(100*updateversion) then begin
      writeln(output, 'You have an old parameter file!');
      halt
   end;
}

   while not eof(input) do begin
      if eoln(input)
      then begin
        readln(input);
        writeln(output);
      end
      else begin
        read(input, c);
        if ord(c) <= HIGH then write(output, c);
      end
   end;

end;
(* end module nohob.themain *)

begin
   themain;
1: end.
