program sumfile(input,output);
(* sumfile: sum of file sizes
   Tom Schneider, 1988 *)

label 1; (* end of program *)

const
(* begin module version *)
version = 1.00; (* of sumfile 1989 March 31
origin 1989 Mar 31 *)
(* end module version *)

(* begin module describe.sumfile *)
(*
name
   sumfile: sum of file sizes

synopsis
   sumfile(input: in, output: out)

files
   input:  the input to this program should be from the Unix command:
       du -s ~/_*
      (where the underscore should be removed; it is there to avoid
       a stupid compiler bug!!)
   output: The output is three columns:
      first column is the first column of the input, the size in kb of
         the various files
      second column is the running sum of the first column
      third column is the same as the second column of the input, the
         names of the files.

description
   The program allows one to find out how many files will fit onto a tape.

examples
   An example of the use of this form is module describe.lister

documentation
   see the man page for du.

author
   Thomas Dana Schneider

bugs
   none known

technical notes
   none.

*)
(* end module describe.sumfile *)

(* begin module copyaline *)
procedure copyaline(var fin, fout: text);
(* copy a line from file fin to file fout *)
begin (* copyaline *)
      while not eoln(fin) do begin
         fout^ := fin^;
         put(fout);
         get(fin)
      end;
      readln(fin);
      writeln(fout);
end; (* copyaline *)
(* end module copyaline *)

(* begin module sumfile.themain *)
procedure themain;
(* the main procedure of the program *)
var
   s: integer; (* input number *)
   sum: integer; (* sum of s *)
begin
   writeln(output,'sumfile ',version:4:2);

   sum := 0;
   while not eof (input) do begin
      read(input, s);
      sum := sum + s;
      write(output,s:10,' ',sum:10,' ');
      copyaline(input,output);
   end
end;
(* end module sumfile.themain *)

begin
   themain;
1: end.
