program unsqz(fin,fout,output);
(* unsqueeze the input file
   tom schneider *)

label 1; (* end of program *)

const
(* begin module version *)
version = 1.07; (* of unsqz.p 1994 sep 6
origin 1987 jun 22 *)
(* end module version *)

(* begin module describe.unsqz *)
(*
name
   unsqz: unsqueeze the input file

synopsis
   unsqz(fin: in, fout: out, output: out);

files
   fin: the output of the sqz program
   fout: the unsqueezed file.
   output: messages to the user

describe
   unsqz reverses the operation of sqz.
   The first character of the fin file is used to indicate where
   lines should be fused together, so no matter what character was used
   to sqz, unsqz will always work.

see also
   sqz.p

author
   thomas dana schneider

bugs
   none known

*)
(* end module describe.unsqz *)


var
   fin, fout: text; (* the input and output files *)

(* begin module halt *)
procedure halt;
begin
   writeln(output,'program halt');
   goto 1
end;
(* end module halt *)

(* begin module themain *)
procedure themain(var filein, fileout: text);
(* the main procedure of the program *)
var
   endofline: char; (* the end of line character *)
begin
   writeln(output,'unsqz ',version:4:2);
   rewrite(fileout);
   reset(filein);
   readln(filein,endofline);

   while not eof(filein) do begin
      while not eoln(filein) do begin
         if filein^=endofline
            then readln(filein)
            else begin
               write(fileout,filein^);
               get(filein);
            end;
      end;
      readln(filein);
      writeln(fileout)
   end;
end;
(* end module themain *)

begin
   themain(fin,fout);
1: end.
