program wordlist(input, output);
(* wordlist: lists words in a file

  Thomas D. Schneider, Ph.D.
  toms@alum.mit.edu
  https://alum.mit.edu/www/toms 

*)

{Block the label, not used in the program
label 1; (* end of program *)
}

const
(* begin module version *)
   version = 1.16; (* of wordlist.p 2016 Jan 24
2016 Jan 24, 1.16: debug
  sed -i.bak "s|'9','0'|'9'|g"                      wordlist.p
2004 Sep  8, 1.15: block label to prevent warning
1996 Feb  9, 1.14: functional
1990 Aug  8, origin from woco 1.08 *)
(* end module version *)

(* begin module describe.wordlist *)
(*
name
   wordlist: lists words in a file

synopsis
   wordlist(input: in, output: out)

files
   input:  a file to find the words in
   output: the words of the file listed one per line

description

   List the words in the input file to the output.
   The program knows about latex constructs a little.
   A word is defined to be any contiguous string of A-Z, a-z, 0-9,
   excluding those that begin with a \.

see also

   woco.p

author

   Thomas Dana Schneider

bugs
   none known

*)
(* end module describe.wordlist *)


(* begin module wordlist.themain *)
procedure themain(var afile: text);
(* the main procedure of the program *)
var
  c: char; (* a character from afile *)
  count: integer; (* count of the words *)
  inside: boolean; (* true if inside a word *)
begin
(*  Don't force the user to have to remove this from the output!
   writeln(output,'* wordlist ',version:4:2);
   writeln(output,'*');
*)

  count := 0;
  inside := false;

  while not eof(afile) do begin
    while not eoln(afile) do begin
      read(afile,c); 
(*
write(output,'[',c,']');
*)
      if (c in [
'a','b','c','d','e','f','g','h','i','j','k','l','m','n','o','p','q','r','s',
't','u','v','w','x','y','z',
'A','B','C','D','E','F','G','H','I','J','K','L','M','N','O','P','Q','R','S',
'T','U','V','W','X','Y','Z',
'0','1','2','3','4','5','6','7','8','9'
               ]) then begin
         (* if this is the start of a word *)
         if not inside then count := count + 1;
(*
if not inside then write(output,count:1);
*)
         inside := true;
      end
      (* don't count control words - skip them *)
      else if c = '\'
           then inside := true
           else begin
              if inside = true then writeln(output);
              inside := false; (* stops words *)
           end;
      if inside then write(output,c);
    end;
    if inside then begin
       writeln(output);
       inside := false;
    end;
    readln(afile);
  end;
end;
(* end module wordlist.themain *)

begin
   themain(input);
{1:} end.
