program yes(output);
(* yes: supply infinite acknowledgment

  Dr. Thomas D. Schneider
  toms@alum.mit.edu
  permanent email: toms@alum.mit.edu (use only if first address fails)
  https://alum.mit.edu/www/toms/

 *)

{Block the label, which is not used:
label 1; (* end of program *)
}

const
(* begin module version *)
   version = 1.02; (* of yes.p 2004 Sep 8
2004 Sep  8, 1.02: block label to avoid GPC warning
1995 Feb  3, 1.01: functional
1994 Mar 31, 1.00: origin *)
(* end module version *)

(* begin module describe.yes *)
(*
name
   yes: supply infinite acknowledgment

synopsis
   yes(output: out)

files
   output: affirmative messages to the user

description

   This program replaces the Unix yes program, which does not exist
under the Solaris operating system.  The program produces an infinite
number of y's to supply the rm program while doing:

    rm *

which would ask for conformation of every name when rm is aliased to
'rm -i'.

    yes | rm *

avoids that.

examples

documentation

see also

author
   Thomas Dana Schneider

bugs

technical notes

*)
(* end module describe.yes *)

(* begin module yes.themain *)
procedure themain(var fout: text);
(* the main procedure of the program *)
begin
  while true do writeln(fout,'y');
end;
(* end module yes.themain *)

begin
   themain(output);
{1:} end.
